// Cribbage.h
// Project: Cribbage
// Stephan Wacker
// 93-06-20

#import <appkit/appkit.h>

#import "deck.h"


@interface Cribbage: Object
{
    id		button;
    id		buttonBox;
    id		firstCutButton;
    id		dealButton;
    id		cutButton;
    id		discardButton;
    id		goButton;
    id		okButton;
    id		doneButton;
    id		newButton;
    
    id		info;
    id		messages;
    id		preferences;
    id		score;
    id		table;
    id		deck;
    id		human;
    id		comp;
    
    id		player;
    id		nextPlayer;
    id		lastPlayer;
    id		loser;
    
    int		games;			// # games played
    BOOL	done;			// current game completed
    int		scoreWhat;		// both hands and the crib
}

- appDidInit: sender;

- new: sender;
- showInfo: sender;
- showScore: sender;
- showPreferences: sender;
- preferences;

- updatePreferences;

// Various actions of the Go button.
- firstCut: sender;
- deal: sender;
- discard: sender;
- cut: sender;
- ok: sender;

- prepareForFirstCut;
- prepareForDealing: aPlayer;
- prepareForDiscarding;
- prepareForCut;
- prepareForPegging;
- continueGame;
- prepareForScoring;
- continueScoring;

// These messages are sent from the players after every move.
// The sender must return immediately afterwards.
//
- didGo: aPlayer;
- didPlay: aPlayer card: (CARD) aCard;
- winner: aPlayer;

- wrongScore: aPlayer correct: (int) points incorrect: (int) claimed;
- explainCurrentScore;
- explainPreviousScore;

// These are private messages.
//
- lastCard: aPlayer;
- swapPlayers;
- installButton: aButton;

@end	// Cribbage
