// Player.h
// Project: Cribbage
// Stephan Wacker
// 93-09-16

#import <appkit/appkit.h>

#import "deck.h"

#import "Table.h"
#import "Hand.h"

@interface Player: Hand
{
    id		table;
    id		deck;
    id		cribbage;
    
    id		cardsInHand;
    id		cardInCrib;
    id		scoreBoard;
    
    BOOL	didGo;
}

- changePegColor;

- (char *) pronoun;
- (char *) possessivePronoun;
- (char *) reflexivePronoun;
- cardInCrib;
- (int) score;

- startGame;
- emptyHand;
- dealCard: (CARD) aCard;
- (CARD) firstCut;
- displayCardAt: (int) i;
- displayHand;

- discard;
- prepareForPegging;
- playOneCard;
- go;

- (BOOL) validCardAt: (int) i;
- (BOOL) canPlay;
- (BOOL) anyCards;
- (BOOL) didGo;
- playCardAt: (int) i;

- scoreHand;
- scoreCrib: (CARD *) cards;
- doScoring: (char *) what points: (int) points;

- peg: (int) points;
- win: (int) gameValue;

@end	// Player
