/*
 * Copyright (c) 1980 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the University of California at Berkeley. The name of the University
 * may not be used to endorse or promote products derived from this
 * software without specific prior written permission. This software
 * is provided ``as is'' without express or implied warranty.
 *
 *	@(#)cribbage.h	5.2 (Berkeley) 3/10/88
 */

/* extern  CARD		deck[ CARDS ];		/* a deck */
/* extern  CARD		phand[ FULLHAND ];	/* player's hand */
/* extern  CARD		chand[ FULLHAND ];	/* computer's hand */
/* extern  CARD		crib[ CINHAND ];	/* the crib */
/* extern  CARD		turnover;		/* the starter */

/* extern  CARD		known[ CARDS ];		/* cards we have seen */
/* extern  int		knownum;		/* # of cards we know */

/* extern  int		pscore;			/* player's score */
/* extern  int		cscore;			/* comp's score */
/* extern  int		glimit;			/* points to win game */

/* extern  int		pgames;			/* player's games won */
/* extern  int		cgames;			/* comp's games won */
/* extern  int		gamecount;		/* # games played */
extern	int		Lastscore[2];		/* previous score for each */

extern  BOOLEAN		iwon;			/* if comp won last */
extern  BOOLEAN		explain;		/* player mistakes explained */
extern  BOOLEAN		rflag;			/* if all cuts random */
extern  BOOLEAN		quiet;			/* if suppress random mess */
extern	BOOLEAN		playing;		/* currently playing game */

extern  char		expl[];			/* string for explanation */
extern  char		prev_expl[];		/* string for explanation */

extern	char		local_buf[];		/* localized messages */
#define LOCAL_BUF	NXLocalizedString(local_buf,NULL,-)

/* Veriables of crib.c */
// extern	BOOLEAN		myturn;

/* Prototypes */
void	msg( const char *, ... );
void	addmsg( const char *, ... );
void	endmsg( void );
BOOLEAN	msgcard( CARD, BOOLEAN );
void	makedeck( CARD * );
void	shuffle( CARD * );
void	cdiscard( BOOLEAN );
void	sorthand( CARD *, int );
void	makeknown( CARD *, int );
int	deal( BOOLEAN );
BOOLEAN	msgcrd( CARD, BOOLEAN, char *, BOOLEAN );
BOOLEAN	cut( BOOLEAN, int );
void	remove_card( CARD, CARD[], int );
void	gamescore( void );
BOOLEAN	playhand( BOOLEAN );
void	discard( BOOLEAN );
void	prcrib( BOOLEAN, BOOLEAN );
void peg_prepare( BOOLEAN );
BOOLEAN peg_comp_can_play( void );
BOOLEAN peg_comp( int * );
BOOLEAN peg_player_can_play( void );
BOOLEAN peg_valid_player_card( int );
BOOLEAN peg_player( CARD );
void	prtable( int );
BOOLEAN	score( BOOLEAN );
BOOLEAN chkscr( int*, int );
void prpeg( int, char, BOOLEAN );
int cchose( CARD [], int, int );
int pegscore( CARD, CARD[], int, int );
int scorehand( CARD[], CARD, int, BOOLEAN, BOOLEAN);
int adjust( CARD[], CARD );
int anysumto( CARD[], int, int, int );
int numofval( CARD[], int, int );
