//#import "../NEXTVegas/CardSet.subproj/cardset.h"

#define BJ_HIT 0
#define BJ_SPLIT 1
#define BJ_DOUBLE 2
#define BJ_STAND 3
#define BJ_SURRENDER 4
#define BJ_NOHINT -1

/************************************************************************************************************************************/

// player num, dealer up card
static int BJ_Hint[26][10] = {
/*==================================================================================================================================*/
/*  Player  |											Dealer Up Card																*/
/*	Hand	|-----------------------------------------------------------------------------------------------------------------------*/
/*			|   2 		    3 		    4 		    5 		    6 		    7 		    8 		    9 		    10 		    A		*/
/*==================================================================================================================================*/
/*    Soft Hand Rules                                                                                                               */
/*----------------------------------------------------------------------------------------------------------------------------------*/
/* A & 9 */	{BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND},
/* A & 8 */	{BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND},
/* A & 7 */	{BJ_STAND,	BJ_STAND,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_STAND,	BJ_STAND,	BJ_HIT,		BJ_HIT,		BJ_HIT},
/* A & 6 */	{BJ_HIT,	BJ_HIT,		BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* A & 5 */	{BJ_HIT,	BJ_HIT,		BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* A & 4 */	{BJ_HIT,	BJ_HIT,		BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* A & 3 */	{BJ_HIT,	BJ_HIT,		BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* A & 2 */	{BJ_HIT,	BJ_HIT,		BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/*----------------------------------------------------------------------------------------------------------------------------------*/
/*    Splitting Rules                                                                                                               */
/*----------------------------------------------------------------------------------------------------------------------------------*/
/* A & A */	{BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT},
/* 10&10 */	{BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND},
/* 9 & 9 */	{BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_STAND,	BJ_STAND},
/* 8 & 8 */	{BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT},
/* 7 & 7 */	{BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* 6 & 6 */	{BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* 5 & 5 */	{BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_HIT,		BJ_HIT},
/* 4 & 4 */	{BJ_HIT,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* 3 & 3 */	{BJ_HIT,	BJ_HIT,		BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* 2 & 2 */	{BJ_HIT,	BJ_HIT,		BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_SPLIT,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/*----------------------------------------------------------------------------------------------------------------------------------*/
/*    Rules for "Stiffs"                                                                                                            */
/*----------------------------------------------------------------------------------------------------------------------------------*/
/* 16 */	{BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* 15 */	{BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* 14 */	{BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* 13 */	{BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/* 12 */	{BJ_HIT,	BJ_HIT,		BJ_STAND,	BJ_STAND,	BJ_STAND,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT},
/*----------------------------------------------------------------------------------------------------------------------------------*/
/*    Doubling Rules                                                                                                                */
/*----------------------------------------------------------------------------------------------------------------------------------*/
/* 11 */	{BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE},
/* 10 */	{BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_HIT,		BJ_HIT},
/* 9 */		{BJ_HIT,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_DOUBLE,	BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT,		BJ_HIT}

};
