
#import <appkit/appkit.h>
#import "../NEXTVegas/NEXTVegas.h"
#import "Dice.h"
#import "CrapsView.h"
#import "craps.h"


#define LOOSER 0
#define WINNER 1
#define NEITHER 2
#define NUM_VIEWS (NUM_PROPS+2)

#define PUCKSOUNDFILE "puck.snd"

#define ODDS_DEFAULT 2

@interface Craps:NVDealer
{
    id  	shooter;
    id  	shooterText;
	id		tableOddsText;
	id		tableTopButton;
    id  	tableAdvice;
	id		numWinsText;
	id		numLosesText;
    
	id		dice;

	int		numWins;
	int		numLoses;
    int  	point;
	int		tableOdds;
	int		pointView;

	id		autoRollButton;
	id		countDownText;
	BOOL	isAutoRoll;
	DPSTimedEntry  autoRollTE;
	int		autoRollSecs;
	int		autoRollCount;

	
	// Inspector Instance Variables
	id		prefOddsButton;
	id		autoRollSlider;
	id		autoRollText;
	
		
	// Sound Instance Variables
	id	puckSound;

    // Proposition Instance Variables
    id	passView;
    id	dontPassView;
    id	comeView;
    id	dontComeView;
    id	fieldView;
    id	placeFourView;
    id	placeFiveView;
    id	placeSixView;
    id	placeEightView;
    id	placeNineView;
    id	placeTenView;
    id	anyCrapsView;
    id	twoView;
    id	threeView;
    id	twelveView;
    id	anySevenView;
    id	hardFourView;
    id	hardTenView;
    id	hardSixView;
    id	hardEightView;
    id	bigSixView;
    id	bigEightView;
    id	hornView;
    id	elevenView;
    id	comeFourView;
    id	comeFiveView;
    id	comeSixView;
    id	comeEightView;
    id	comeNineView;
    id	comeTenView;
    id	dontComeFourView;
    id	dontComeFiveView;
    id	dontComeSixView;
    id	dontComeEightView;
    id	dontComeNineView;
    id	dontComeTenView;
	
	id	puckOnImage;
	id	puckOffImage;
    
    id betView[NUM_VIEWS];  //  pointers to the above views
}

/**********************************************************************************  
 *                                Craps Methods                                   *
 **********************************************************************************/
- (BOOL)anyBetsTooLow;
- (BOOL)anyBetsTooHigh;
- checkBets:(int)die1 :(int)die2 status:(int)status;
- gameWasWon:(BOOL)won;
- (int)getRoll:(int *)roll;
- (int) point;
- (struct proposition *) proposition:(int)propNum;
- resetChips;
- setPayoffs;
- (int)tableOdds;
- takeBetsOff:(BOOL)flag;
- trueOdds:(int *)p for:(int *)c forRoll:(int)roll;
- enableViews:(BOOL)flag;
- toggleAutoRoll:sender;
- clockTick;
- beginCountDown;
- endCountDown;
/**********************************************************************************  
 *                               Player Methods                                   *
 **********************************************************************************/
- playerDidClose:player;	// From NVDealer
- playerDidJoin:player;		// From NVDealer
- playerDidThrow:sender;
- (BOOL) playerWillThrow:sender;
- setNewShooter;
- setShooter:aPlayer;

/**********************************************************************************  
 *                           Preferences Type Methods                             *
 **********************************************************************************/
- preferencesChanged:sender;
- (int)tableOdds;
- revertPreferences:sender;
- setPreferences:sender;

/**********************************************************************************  
 *                             Other NVDealer Methods                             *
 **********************************************************************************/
- (int)collectAllBetsForPlayer:(int)playerNum;	// From NVDealer
- finishSessionAndClose;						// From NVDealer
- (BOOL)hasRules;								// From NVDealer
- view:aView wasLoadedOnTable:tableObject;		// From NVDealer

@end
