
#import <appkit/appkit.h>
#import "Dealer.h"
#import "craps.h"

#define MAX_PLAYERS 4

#define P1_COLOR 0.0
#define P1_TEXTCOLOR 1.0
#define P2_COLOR .25
#define P2_TEXTCOLOR 1
#define P3_COLOR .5
#define P3_TEXTCOLOR 1
#define P4_COLOR .75
#define P4_TEXTCOLOR 1

struct chips {
    float textColor;
    float chipColor;
    float x;
    float y;
    float r;
}; 

@interface TableView:View
{
    id  dealer;
    
    id displayFont;
    id puckFont;
    BOOL drawingPuck;
            
    int tag;
    
    struct bet bets[MAX_PLAYERS];
    struct chips chip[MAX_PLAYERS];
}

- initializePropositions; 
- initializeChipPlacement;
- setTag:(int)aTag;
- setTrackingRectForWindow:aWindow;
- (int)tag;

- bet:(int)units forPlayer:player num:(int)playerNum;
- removeBet:(int)units forPlayer:player num:(int)playerNum;
- layOdds:(int)units forPlayer:player num:(int)playerNum;
- removeOdds:(int)units forPlayer:player num:(int)playerNum;

- payOutForRoll:(int)roll;
- clearBets;
- getBetsFrom:otherView;
- getBet:(int *)bet odds:(int *)odds forPlayer:(int)playerNum;
- setBet:(int)bet odds:(int)odds forPlayer:(int)playerNum;
- switchBetOnOffForPlayer:(int) playerNum;
- addBetsFrom:otherView;
- tradeBetsWith:otherView;

@end
