#import <appkit/appkit.h>
#import "../NEXTVegas/NEXTVegas.h"

#define KL_DRAWONE 1
#define KL_DRAWTHREE 3
#define KL_MINPASS 3
#define KL_INFINITEPASS -1


/**************************************************************************************
 *    Klondike                                                                        *
 *                                                                                    *
 *   This module comes from the game Solitaire.app.  I have basically ported the      *
 *   module to NEXTVegas.  I have also added a few things like the betting stuff.     *
 *                                                                                    *
 **************************************************************************************/

@interface Klondike:NVDealer
{
    id drawPileView;
    id discardPileView;
    
    id gamePileView1;
    id gamePileView2;
    id gamePileView3;
    id gamePileView4;
    id gamePileView5;
    id gamePileView6;
    id gamePileView7;
	id gameCardPileViews[7];

    id suitPileView1;
    id suitPileView2;
    id suitPileView3;
    id suitPileView4;
	id suitCardPileViews[4];
    
    id recycleCardPile;
    
    id suitPileDelegate;
    id drawPileDelegate;
    id gamePileDelegate;
    id discardPileDelegate;

    id prevDeck;
	
	id	amountBetText;
	id	amountWonText;
	id	totalWonText;
	id	dealButton;
	
	BOOL gameInProgress;
	
	id	drawPref;
	
	BOOL	infiniteDraw;
	
	int	bank;
}

- startGame:sender;
- restartGame:sender;
- setupGame:(BOOL)redeal;
- checkForWin;
- win;
- enableDealButton;
- (int)totalCollected;
- endGame;
- findHomeFor:cardPile fromPileView:aCardPileView;

@end
