
#import "ATM.h"

@implementation ATM

- changePINFor:aPlayer
{
    char newPin[5], dialogue[256];
    
    sprintf(dialogue, "%s, please enter your new 4-digit PIN number, and press [ENTER]...", [aPlayer playerName]);
    [dialogueBox setStringValue:dialogue];
    [[inputBox setStringValue:""] setTextGray:NX_BLACK];
    [inputBlocker setStringValue:""];

    [inputBox selectText:self];
    [[panel contentView] addSubview:inputBlocker];
    gettingPIN = YES;
    strcpy(pin, "");

    if([NXApp runModalFor:panel] == NX_RUNABORTED) {
        return self;
    }
    
    gettingPIN = YES;
    strncpy(newPin, pin, 5);
    strcpy(pin, "");
    
    [dialogueBox setStringValue:"Please enter that PIN again to confirm, and press [ENTER]..."];
    [inputBox setStringValue:""];
    [inputBlocker setStringValue:""];
    [inputBox selectText:self];
    
    if([NXApp runModalFor:panel] == NX_RUNABORTED) {
        return self;
    }
    
    gettingPIN = NO;
    [inputBox setStringValue:""];
    [inputBox setTextGray:NX_WHITE];
    
    
    if(strncmp(pin, newPin, 4) == 0) {
        [aPlayer setPIN:pin];
    } else {
        sprintf(dialogue, "I am unable to give you a new PIN because you did not enter the same number twice.\n\nTry Again?");
	[dialogueBox setStringValue:dialogue];
        [inputBox selectText:self];
	
	if([NXApp runModalFor:panel] == NX_RUNABORTED) {
	    return nil;
	}
	return [self changePINFor:aPlayer];
    }
    
    return self;
} 

- changeNameFor:aPlayer
{
    char dialogue[256], *newName;
    
    sprintf(dialogue, "Change Your Name...\n\nPlease enter the new name that you would like to use, and press [ENTER]...");
    
    [dialogueBox setStringValue:dialogue];
    [inputBox setStringValue:""];

    gettingPIN = NO;
    [inputBox setStringValue:""];
    [inputBox selectText:self];
    
    if([NXApp runModalFor:panel] == NX_RUNABORTED)
	{
        return self;
    }
	
	newName = (char *)[inputBox stringValue];
	
	[[aPlayer setPName:newName] updateWindow];
	
	return self;
}

- endModal:sender
{
    //[[sender window] orderOut:self];
    switch([[sender selectedCell] tag]) {
        case SET:
	    [NXApp stopModal];
	    break;
	case CANCEL:
	    [NXApp abortModal];
	    break;
    }
    
    return self;
}

- enter:sender
{
    return self;
}

- (BOOL)getPINFor:aPlayer
{
    int count = 0;
    char dialogue[256];
    
    if(strcmp([aPlayer pin], "") == 0) {
        if([self welcomePlayer:aPlayer] == nil || [self changePINFor:aPlayer] == nil)
	    return NO;
	else
	    return YES;
    }
    
    sprintf(dialogue, "%s, please enter your 4-digit PIN number, and press [ENTER]...", [aPlayer playerName]);
    [dialogueBox setStringValue:dialogue];
    
    do {
	if(count > 3) {
	    //[panel orderOut:self];
	    return NO;
	}
	
	gettingPIN = YES;
	[[inputBox setStringValue:""] setTextGray:NX_BLACK];
	[inputBlocker setStringValue:""];
	[inputBox selectText:self];
	[[panel contentView] addSubview:inputBlocker];
	strcpy(pin, "");
	
	if([NXApp runModalFor:panel] == NX_RUNABORTED) {
	    return NO;
	}
	gettingPIN = NO;
	[inputBox setStringValue:""];
	[inputBox setTextGray:NX_WHITE];
	count++;
	
	if(strcmp(pin, [aPlayer pin]) != 0) {
	    NXBeep();
	    sprintf(dialogue, "Invalid PIN number!  Try again...\n\n%s, please enter your 4-digit PIN number, and press [ENTER]...", [aPlayer playerName]);
	    [dialogueBox setStringValue:dialogue];
	}
    } while(strcmp(pin, [aPlayer pin]) != 0);
    
    return YES;
}

- transferMoneyFromPlayer:aPlayer
{
    char dialogue[1024];
	int pnum, amount;
	
	sprintf(dialogue, "Which player would you like to transfer money to?\n\n     1.  %s\n     2. %s\n     3.  %s\n     4. %s\n\n(Enter number 1 - 4)", 
		([PBoss() playerAt:0] == nil) ? "" : [[PBoss() playerAt:0] playerName], 
		([PBoss() playerAt:1] == nil) ? "" : [[PBoss() playerAt:1] playerName], 
		([PBoss() playerAt:2] == nil) ? "" : [[PBoss() playerAt:2] playerName], 
		([PBoss() playerAt:3] == nil) ? "" : [[PBoss() playerAt:3] playerName]);
    [dialogueBox setStringValue:dialogue];
    [inputBox setStringValue:""];
    [inputBox selectText:self];

    if([NXApp runModalFor:panel] == NX_RUNABORTED) 
	{
        return self;
    }
	
	pnum = [inputBox intValue]-1;
	if(pnum < 0 || pnum >= 4 || [PBoss() playerAt:pnum] == nil)
	{
		sprintf(dialogue, "The player you have chosen does not exist.\n\nTo try again, press [ENTER].\nTo cancel, press [CANCEL]");
		[dialogueBox setStringValue:dialogue];
		[inputBox setStringValue:""];
		[inputBox selectText:self];
	
		if([NXApp runModalFor:panel] == NX_RUNABORTED) 
		{
			return nil;
		}
		
		return [self transferMoneyFromPlayer:aPlayer];
	}
	
    
    sprintf(dialogue, "Please enter the amount that you would like to transfer to %s, and press [ENTER]...", [[PBoss() playerAt:pnum] playerName]); 
    [dialogueBox setStringValue:dialogue];
    [inputBox setStringValue:""];
    [inputBox selectText:self];
    
    if([NXApp runModalFor:panel] == NX_RUNABORTED) 
	{
        return self;
    }
    
    amount = [inputBox intValue];
	if(amount < 0) amount = 0;
	if(amount > [aPlayer amountInBank])
		amount = [aPlayer amountInBank];
    
    [inputBox setStringValue:""];

	[aPlayer depositToBank:-amount];
    [[PBoss() playerAt:pnum] depositToBank:amount];
		
	return self;
}

- withdrawFor:aPlayer
{
    char dialogue[256];
    
    sprintf(dialogue, "Purchase Chips...\n\nAmount In Savings:  $%d\n\nPlease enter the amount of chips you would like to purchase, and press [ENTER]...", [aPlayer amountInSavings]);
    
    [dialogueBox setStringValue:dialogue];
    [inputBox setStringValue:""];

    [inputBox selectText:self];
    
    if([NXApp runModalFor:panel] == NX_RUNABORTED) {
        return self;
    }
    
    [[aPlayer depositToBank:[inputBox intValue]] 
           addToSavings:-[inputBox intValue]];
      
    sprintf(dialogue, "Purchase Chips...\n\nAmount Purchased: $%d\n\nReturn to Main Menu?", [inputBox intValue]);

    [dialogueBox setStringValue:dialogue];
    [[inputBox setStringValue:""] selectText:self];
    
    if([NXApp runModalFor:panel] == NX_RUNABORTED) {
        return nil;
    }
    
    return self;
}

- cashInFor:aPlayer
{
    char dialogue[256];
    
    sprintf(dialogue, "Cash In Chips...\n\n     Amount In Chips:  $%d\n     Amount In Savings:  $%d\n\nPlease enter the amount that you would like to cash in, and press [ENTER]...", [aPlayer amountInBank], [aPlayer amountInSavings]);
    
    [dialogueBox setStringValue:dialogue];
    [inputBox setStringValue:""];

    [inputBox selectText:self];
    
    if([NXApp runModalFor:panel] == NX_RUNABORTED) {
        return self;
    }
    
    if([inputBox intValue] <= [aPlayer amountInBank]) {
	[[aPlayer depositToBank:-[inputBox intValue]] 
		addToSavings:[inputBox intValue]];
	    
	sprintf(dialogue, "Cash In Chips...\n\n     Amount In Savings: $%d\n\nReturn to Main Menu?", [aPlayer amountInSavings]);
    
	[dialogueBox setStringValue:dialogue];
	[[inputBox setStringValue:""] selectText:self];
	
	if([NXApp runModalFor:panel] == NX_RUNABORTED) {
	    return nil;
	}
    } else {
	NXBeep();
	sprintf(dialogue, "Cash In Chips...\n\nThe amount you have entered ($%d) is greater than the amount you have in chips ($%d).\n\nReturn to Main Menu?", [inputBox intValue], [aPlayer amountInBank]);
    
	[dialogueBox setStringValue:dialogue];
	[[inputBox setStringValue:""] selectText:self];
	
	if([NXApp runModalFor:panel] == NX_RUNABORTED) {
	    return nil;
	}
    }
    
    return self;
}
    
- welcomePlayer:aPlayer
{
    char dialogue[256];
    
    sprintf(dialogue, "Welcome %s!\n\nEvery new player must select their own PIN number to access this ATM.  After choosing a PIN, you can purchase chips and begin playing...\n\nPress [ENTER] to go to select your PIN...", [aPlayer playerName]);
    
    [dialogueBox setStringValue:dialogue];
    [inputBox setStringValue:""];
    [inputBlocker setStringValue:""];

    [inputBox selectText:self];
    
    if([NXApp runModalFor:panel] == NX_RUNABORTED) {
        return nil;
    }
    
    return self;
}    

- runATMFor:aPlayer
{
    char dialogue[256];
    BOOL finished;
    char *ppin = [aPlayer pin];
    
    
    if(strcmp(ppin, "") != 0 && ![self getPINFor:aPlayer]) 
	{
        [panel orderOut:self];
		return nil;
    } 
	else if(strcmp(ppin, "") == 0) 
	{  // new player... 
        if([self welcomePlayer:aPlayer] == nil || [self changePINFor:aPlayer] == nil) 
		{
			[panel orderOut:self];
			return nil;
		}
    }
    
    finished = NO;
    while(finished == NO) 
	{
		sprintf(dialogue, "Welcome to the NEXTVegas ATM\n\n%s, please enter the number of the function that you would like to perform:\n\n     1:  Purchase Chips\n     2:  Cash In Chips\n     3:  Change PIN\n     4:  Change Name\n     5:  Transfer $ to Other Player\n     6.  Exit", [aPlayer playerName]);
	
		[dialogueBox setStringValue:dialogue];
		[inputBox setStringValue:""];
		[inputBox selectText:self];
	
		if([NXApp runModalFor:panel] == NX_RUNABORTED) 
		{
			[panel orderOut:self];
			return self;
		}
	
		switch([inputBox intValue]) 
		{
			case 1:
				if([self withdrawFor:aPlayer] == nil)
					finished = YES;
				break;
			case 2:
				if([self cashInFor:aPlayer] == nil)
					finished = YES;
				break;
			case 3:
				if([self changePINFor:aPlayer] == nil)
					finished = YES;
				break;
			case 4:
				if([self changeNameFor:aPlayer] == nil)
					finished = YES;
				break;
			case 5:
				if([self transferMoneyFromPlayer:aPlayer] == nil)
					finished = YES;
				break;
			case 6:
				finished = YES;
				break;
			default:
				NXBeep();
				break;
		}
    }
    
    [panel orderOut:self];

    return self;
}

- (BOOL)getPINOnlyFor:aPlayer
{
	BOOL ret;
	
	ret = [self getPINFor:aPlayer];
	
	[panel orderOut:self];
	
	return ret;
}

- textDidGetKeys:sender isEmpty:(BOOL)flag
{
    char buf[100];
    int len, i;
    
    strcpy(buf, "");
    
    if(gettingPIN) 
	{
        [[panel contentView] addSubview:inputBlocker];
		len = strlen([inputBox stringValue]);
		if(len > 4) 
		{
			NXBeep();
		} 
		else 
		{
			strcpy(pin, [inputBox stringValue]);
			for(i=0; i<len; i++) 
			{
				sprintf(buf, "%s*", buf);
			}
			[inputBlocker setStringValue:buf];
		}
    }
        
    return self;
}

- window
{
    return panel;
}
@end
