#import <appkit/appkit.h>

#define NV_CHIPTYPE1 0
#define NV_CHIPTYPE2 1
#define NV_CHIPTYPE3 2
#define NV_CHIPTYPE4 3
#define NV_CHIPTYPE5 4

#define NV_CHIPSIZELARGE 0
#define NV_CHIPSIZESMALL 1

@interface ChipPile:Object
{
	int		ownerIndex;
	int		amount;
    BOOL	isOn;
	int		chipType;
	int		chipSize;
	int		tag;
	int		draggedFromRow;
	int		draggedFromColumn;
	float	xOffset, yOffset;
	float	maxWidth, maxHeight;
	int		numChipsToDraw, numChipsDrawn;
	BOOL	showValueInsteadOfTotal;
	int		chipValue;
	
}

- init;
- initType:(int)cpType size:(int)cpSize value:(int)cpValue;
- copyFromZone:(NXZone *)zone;

- setXOffset:(float)xoffset yOffset:(float)yoffset;
- setMaxWidth:(float)maxwidth maxHeight:(float)maxheight;

- setChipType:(int)aValue;
- (int)chipType;
- setChipSize:(int)aValue;
- (int)chipSize;
- setChipValue:(int)aValue;
- (int)chipValue;
- setOwnerIndex:(int)aPlayerIndex;
- (int)ownerIndex;
- setTag:(int)aTag;
- (int)tag;
- getChipSize:(NXSize *)size;
- getPileSize:(NXSize *)size;
- setNumChips:(int)numtodraw;
- (int)numChips;

- addChips:(int)numChips;
- removeChips:(int)numChips;
- setAmount:(int)aValue;
- (int)amount;
- addAmount:(int)units;
- multiplyBy:(float)units;
- empty;
- setOn:(BOOL)isOn;
- (BOOL)isOn;
- showValueInsteadOfTotal:(BOOL)flag;
- (BOOL)showsValue;
- flip;
- addPile:aPile;
- removePile:aPile;

- drawChipPileAt:(NXPoint *)aPoint;
- drawContentsAt:(NXPoint *)aPoint;
- drawOutlineAt:(NXPoint *)aPoint;

- drawDragPile:sender;
- tempDragImage;
- setDragRow:(int)row col:(int)col;
- getDragRow:(int *)row col:(int *)col;

- read:(NXTypedStream *)theStream;
- write:(NXTypedStream *)theStream;

- printToStderr;

@end