
/*----------------------------------------------------------------------------
|-----------------------------------------------------------------------------
|
|    ModuleInfo : Object
|
|    Each instances of this class stores information about a .soltaire
|    module.  The ModuleList class stores these instances.
|
|    These classes based on code found in BackSpace.app by Sam Streeper.
|
|-----------------------------------------------------------------------------
\----------------------------------------------------------------------------*/

#import <appkit/appkit.h>

@interface ModuleInfo:Object
{
    NXBundle	*theBundle;
    id			controller;     // game controller
    char		*gameName;	// localized game name
    char		*realName;       // nonlocalized game name
    BOOL		failed;         // true if failed to load
	
	char		iconPath[MAXPATHLEN+1];
	BOOL		hasIcon;
}

- initWithController:aController name:(const char *)aName 
                                 path:(const char *)aPath;
				 
- setController:newController;
- controller;
- setFailed:(BOOL)flag;
- (BOOL)failed;
- (const char *)gameName;
- (const char *)realName;
- (const char *)path;
- (char *)iconPath;
- (BOOL)hasIcon;
- (NXBundle *)bundle;
- free;

@end

/*----------------------------------------------------------------------------
|-----------------------------------------------------------------------------
|
|    ModuleList : List
|
|    Custom list to hold instances of the ModuleInfo class.
|
|    These classes based on code found in BackSpace.app by Sam Streeper.
|
|-----------------------------------------------------------------------------
\----------------------------------------------------------------------------*/

@interface ModuleList:List
{
}

- (const char *)nameAt:(int)i;
- (const char *)realNameAt:(int)i;
- controllerAt:(int)i;
- sort;
- (const char *)pathAt:(int)i;

@end
