#import <appkit/appkit.h>
#import "PitBoss.h"
#import "Player.subproj/Player.h"

/**************************************************************************************
 *    NVDealer                                                                        *
 *                                                                                    *
 *    NVDealer is an abstract superclass that defines some of the basic methods that  *
 *    all dealers must incorporate in order to be a NEXTVegas dealer.  Every game     * 
 *    must have one dealer class and it must inherit from NVDealer.                   *
 *                                                                                    *
 **************************************************************************************/

@interface NVDealer:Object
{
    id	pitBoss;
    id	table;
	id	bundle;
	id	dealerText;
	id	gameView;
	id	inspector;

    int tableMax;
    int tableMin;
	char *gameName;
	
	id	rulesWindow;
}

/***************************************************************************************
 *                            Inspector And Rules Methods                              *
 ***************************************************************************************/
- (BOOL)hasRules;
- inspector:sender;
- inspectorWillBeRemoved:sender;
- inspectorWasInstalled:sender;
- rulesWindow;
- setPreferences:sender;
- revertPreferences:sender;
- preferencesChanged:sender;

 
/***************************************************************************************
 *                                  Player Methods                                     *
 ***************************************************************************************/
- (int)collectAllBetsForPlayer:(int)playerNum;
- currentPlayer;
- (int)numPlayers;
- playerDidBet:aPlayer;
- playerDidClose:aPlayer;
- playerDidJoin:player;
- (BOOL)playerWillClose:aPlayer;
- (BOOL)playerWillJoin:sender;

/***************************************************************************************
 *                                  Table Methods                                      *
 ***************************************************************************************/
- gameView;
- setTableMax:(int)aNumber;
- setTableMin:(int)aNumber;
- (int)tableMax;
- (int)tableMin;
- table;
- view:aView wasLoadedOnTable:tableObject;

/***************************************************************************************
 *                               Other Misc. Methods                                   *
 ***************************************************************************************/
- initFromBundle:aBundle withName:(const char *)name;
- finishSessionAndClose;
- pitBoss;
- (int)randomIntBetween:(int)lowNum :(int)highNum;
- (float)randomFloatBetween:(float)lowNum :(float)highNum;
- say:(char *)text;
- selectCellWithTag:(int)tag forPopUpButton:button;
- (int)tagOfSelectedCellInPopUpButton:popUpButton;
- runDebug;

/***************************************************************************************
 *                        Card/CardPile/CardPileView Methods                           *
 ***************************************************************************************/
- addDecks:(int)n toView:view emptyFirst:(BOOL)willEmpty andShuffle:(BOOL)willShuffle;
- newDeck:(int)numDecks forView:view;
- setUserValueForPile:cardPile aceHigh:(BOOL)flag;

@end
