
#import <appkit/appkit.h>
#import "NEXTVegas.h"
#import "PrefController.h"
#import "ATM.h"
#import "Casino.h"

#define INITIAL_SOUNDEFFECT_SIZE 8

extern id Prefs(void);
extern id PBoss(void);
extern id Dealer(void);

@interface PitBoss:Object
{
    id  	atm;
	id		casino;
    id		dealer;
	id		table;
	id		dealerText;
	id		tableView;
	
	int		numWins;
	int		numLoses;
	id		houseMaxText;
	int		houseMax;
	id		houseMinText;
	int		houseMin;
	id		currentPlayerText;
	
	id		welcomeView;
    
    id 		infoPanel;
	id		infoPanelVersionText;
	
	id		rulesMenuCell;
    
	id  	newPlayer;
	id		currentPlayer;
	id		newPlayerNameText;
	id		newPlayerNameWindow;
	id		playerList[MAX_PLAYERS];
	int		numPlayers;
	
	id		pmenu1;
	id		pmenu2;
	id		pmenu3;
	id		pmenu4;
	id		pMenu[MAX_PLAYERS];
	id		windowsMenu;
    
	id  	prefController;
    float 	offset;
	
	id		soundEffect[MAX_SOUNDS];
	BOOL	soundEnabled;
	//int		numSounds;
    
	BOOL 	appIsTerminating;
    char 	*gameFile;
	
}

/**********************************************************************************  
 *                               Player Methods                                   *
 **********************************************************************************/
- newPlayer:sender;
- addPlayerIfNecessary;
- addPlayerFromFile:(const char *)filename;
- currentPlayer;
- (char *)nameOfPlayer:(int)playerNum;
- (int)nextPlayerSlot;
- (int)numPlayers;
- openPlayer:sender;
- playerAt:(int)tag;
- removePlayer:sender;
- savePlayer:sender;
- savePlayerAs:sender;
- setCurrentPlayer:player;

- changeCurrentPlayer:sender;

/**********************************************************************************  
 *                                 ATM Methods                                    *
 **********************************************************************************/
- runATM:sender;
- runATMForPlayer:aPlayer pinOnly:(BOOL)flag;

/**********************************************************************************  
 *                                Game Methods                                    *
 **********************************************************************************/
- newGame:controller named:(const char *)gamename;
- closeGame:sender;
- closeGameAndBringBackWelcome:(BOOL)flag;
- insertGameView:gameView;
- (BOOL)gameWillLoad:(const char *)gamename;

/**********************************************************************************  
 *                                    Sound                                       *
 **********************************************************************************/
- (int)addSoundFromSection:(char *)soundfile;
- playSound:(int)index;
- removeSound:(int)index;
- setSoundEnabled:(BOOL)flag;
- (BOOL)soundEnabled;

/**********************************************************************************  
 *                                Misc. Methods                                   *
 **********************************************************************************/
- (BOOL)appIsTerminating;
- dealer;
- dealerText;
- currentPlayerText;
- endModal:sender;
- help:sender;
- preferences:sender;
- showInfo:sender;
- showRules:sender;
- setHouseMin:(int)aNumber;
- setHouseMax:(int)aNumber;
- suggestions:sender;
- (int)houseMin;
- (int)houseMax;
- tableWindow;
- tableView;
- (float)NVVersion;
- updatePlayerMenus;
- updatePlayerMenuAt:(int)playerNum;
@end

/**********************************************************************************  
 *                               Delegate Methods                                 *
 **********************************************************************************/
@interface PitBoss (ApplicationDelegate)
- (BOOL)appAcceptsAnotherFile:sender;
- (int)app:sender openFile:(const char *)filename type:(const char *)aType;
- appWillTerminate:sender;
- appDidBecomeActive:sender;
@end

