
#import <appkit/appkit.h>
#import "../NVDealer.h"
#import "../PitBoss.h"
#import "PlayerView.h"

#define DEFAULT 0
#define ONE 1
#define FIVE 5
#define TWENTYFIVE 25
#define USE_CHIP_MATRIX -1

#define NV_1DOLLARCHIP 0
#define NV_5DOLLARCHIP 1
#define NV_25DOLLARCHIP 2
#define NV_50DOLLARCHIP 3
#define NV_100DOLLARCHIP 4
#define NV_NUMPLAYERCHIPPILES 5

struct _chip
{
	id	view;
	id	box;
	id	pile;
};



@interface Player:Object
{
    int amountInSavings;
	int amountAtStart;
    id  bankText;
    id  cashText;
    id  totalText;
	id	todaysText;
    
    int playerNumber;
    char playerName[100];
    
    id  window;
    id  dealer;
	id	pitBoss;
    
    id betMatrix;
    
    id  chipsMatrix;
    
    id  chip1View;
    id  chip5View;
    id  chip25View;
	id	chip50View;
	id	chip100View;
	id	selectedView;
    id  chip1Box;
    id  chip5Box;
    id  chip25Box;
	id	chip50Box;
	id	chip100Box;
    
    char *saveFile;
    
    int  tag;
    char  pin[5];
	
	char creationDate[10];
	
	id	removeSound;
	
	int	playerFileVersion;
	
	struct _chip chip[NV_NUMPLAYERCHIPPILES];

}

- depositToBank:(int)bankAmount;
- addToSavings:(int)savingsAmount;
- (int) amountInBank;
- (int) amountInSavings;
- collectAllBets:sender;
- finishedBetting:sender;
- (char *)pin;
- (char *)playerName;
- (int) selectedChip;
- setPIN:(char *)pinNumber;
- setPName:(const char *)name;
- setTag:(int)aTag;
- (int) tag;
- updateWindow;
- window;

- addChip:(int)value;
- disperse:(int)num;
- disperse:(int)num startingWith:(int)pileNum;
- viewWasSelected:aView;
- removeChip:(int)value;
- (int)remove:(int)num startingWith:(int)pileNum;
- selectView:(int)viewIndex;

- setSaveFile:(const char *)filename isFirstTime:(BOOL)flag;
- (char *)saveFile;
- saveToTypedStream:(NXTypedStream *)typedStream;
- loadFromTypedStream:(NXTypedStream *)typedStream;

@end
