// PaletteView.h
// By Jayson Adams, NeXT Developer Support Team
// You may freely copy, distribute and reuse the code in this example.
// NeXT disclaims any warranty of any kind, expressed or implied, as to its
// fitness for any particular use.

#import <appkit/View.h>
#import <math.h>
#import <appkit/NXImage.h>
#import <appkit/Window.h>

@interface PlayerView:View
{
    NXRect   hotRect;
    id	     player;
    
    NXPoint  lastOffset;
	NXPoint		chipPoint;
	
	id		chipPile;
	id		draggingPBoard;
	NXAtom 	*NVBetPBoardType;
	
	int value;
	BOOL isSelected;
	BOOL framed;
	id	textFont;
	
	int tag;
	int keyEquiv;
}

/* instance methods */
- (BOOL)acceptsFirstMouse;
- (NXPoint) lastOffset;

- pile;

- addChips:(int)num;
- addChips:(int)num total:(int)total;
- setChipValue:(int)aValue;
- (int)chipValue;
- setSelected:(BOOL)flag;
- (BOOL)isSelected;
- (int)totalChipValue;

- setTag:(int)aTag;
- (int)tag;

- mouseDown:(NXEvent *)theEvent;
- drawSelf:(NXRect *)rects :(int)count;

- (NXDragOperation)draggingEntered:sender;
- draggingExited:sender;
- (BOOL)performDragOperation:sender;
- (BOOL)prepareForDragOperation:sender;
- concludeDragOperation:sender;

@end

